import {CreatedByModel} from "../created-by.model";
import {Timestamp} from "../timestamp";
import {OrderType, PointType} from "../../enum";
import {ChargingTransactionRecords} from "../charging-transaction";
import {ServiceChargeModel} from "../service-charge.model";
import {PublicUserVehicle} from "../public-user-vehicle.model";
import {PhoneNumberModel} from "../phone-number-model";
import {AddressApiModel, StateModel} from "./address.api.model";
import {GstModel} from "./gst-record-api.model";

export interface InvoiceApiModel {
    id: string;
    invoiceId: string;
    bookingId: string;
    bookingRef: string;
    bookingDate: Timestamp;
    bookingStartTime: number;
    bookingEndTime: number;
    invoiceNo: number;
    chargerId: string;
    chargerName: string;
    initialBatteryPercentage?: number;
    chargerAddress: AddressApiModel;
    chargerState: StateModel;
    gst: GstModel;
    customerName: string;
    chargingDate: Timestamp;
    startTime: Timestamp;
    endTime: Timestamp;
    unitConsumed: number;
    state: string;
    connectorNo: number;
    userId: string;
    unitRate: number;
    orderType: OrderType;
    stopReason: string;
    transactionId: number;
    currentTransactionId: number;
    transaction: ChargingTransactionRecords;
    meterStart: number;
    meterStop: number;
    isDeleted: boolean;
    deletedAt: Timestamp | null;
    createdAt: Timestamp;
    updatedAt: Timestamp;
    createdBy: CreatedByModel;
    updatedBy: CreatedByModel;
    deletedBy: CreatedByModel | null;
    serviceChargeInfo: ServiceChargeModel;
    serviceCharge: number;
    taxAmount: number;
    subTotal: number;
    pointType: PointType;
    batteryPercentage: number;
    recordHealth: 'bad' | 'good';
    phoneNumber: PhoneNumberModel;
    totalConsumedUnits: number;
    totalAmount: number;
    bookingUnit: number;
    bookingAmount: number;
    bookingDuration: number;
    vehicle: PublicUserVehicle
}
